]> git.proxmox.com Git - grub2.git/blame - util/grub-mkconfig.in
Put recheck back
[grub2.git] / util / grub-mkconfig.in
CommitLineData
1246efeb
CW
1#! /bin/sh
2set -e
ebd97f6e 3
4# Generate grub.cfg by inspecting /boot contents.
d500ed12 5# Copyright (C) 2006,2007,2008,2009,2010 Free Software Foundation, Inc.
ebd97f6e 6#
5a79f472 7# GRUB is free software: you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation, either version 3 of the License, or
ebd97f6e 10# (at your option) any later version.
11#
5a79f472 12# GRUB is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
ebd97f6e 16#
17# You should have received a copy of the GNU General Public License
5a79f472 18# along with GRUB. If not, see <http://www.gnu.org/licenses/>.
ebd97f6e 19
20transform="@program_transform_name@"
21
2e610d62 22prefix=@prefix@
23exec_prefix=@exec_prefix@
24sbindir=@sbindir@
4417aae6 25bindir=@bindir@
42c71976 26libdir=@libdir@
ebd97f6e 27sysconfdir=@sysconfdir@
0ea7c4f9
GS
28PACKAGE_NAME=@PACKAGE_NAME@
29PACKAGE_VERSION=@PACKAGE_VERSION@
38e55e90 30host_os=@host_os@
29a6b9e8 31datarootdir=@datarootdir@
b969c52f 32datadir=@datadir@
33pkgdatadir=${datadir}/`echo @PACKAGE_TARNAME@ | sed "${transform}"`
18ade780 34grub_cfg=""
35grub_mkconfig_dir=${sysconfdir}/grub.d
2e610d62 36
0ea7c4f9
GS
37self=`basename $0`
38
4417aae6
VS
39grub_probe=${sbindir}/`echo grub-probe | sed "${transform}"`
40grub_script_check="${bindir}/`echo grub-script-check | sed "${transform}"`"
ebd97f6e 41
b9fe6ea2
YB
42GRUB_PREFIX=`echo '/@bootdirname@/@grubdirname@' | sed "s,//*,/,g"`
43
68807e5f 44# Usage: usage
45# Print the usage.
46usage () {
47 cat <<EOF
0ea7c4f9 48Usage: $self [OPTION]
18ade780 49Generate a grub config file
68807e5f 50
18ade780 51 -o, --output=FILE output generated config to FILE [default=stdout]
68807e5f 52 -h, --help print this message and exit
53 -v, --version print the version information and exit
68807e5f 54
55Report bugs to <bug-grub@gnu.org>.
56EOF
57}
58
b02c7c8f
BC
59argument () {
60 opt=$1
61 shift
62
63 if test $# -eq 0; then
64 echo "$0: option requires an argument -- '$opt'" 1>&2
65 exit 1
66 fi
67 echo $1
68}
69
68807e5f 70# Check the arguments.
7a64e28d
BC
71while test $# -gt 0
72do
73 option=$1
74 shift
75
68807e5f 76 case "$option" in
77 -h | --help)
78 usage
79 exit 0 ;;
80 -v | --version)
0ea7c4f9 81 echo "$self (${PACKAGE_NAME}) ${PACKAGE_VERSION}"
68807e5f 82 exit 0 ;;
7a64e28d 83 -o | --output)
b02c7c8f 84 grub_cfg=`argument $option "$@"`; shift;;
880fc3c4 85 --output=*)
18ade780 86 grub_cfg=`echo "$option" | sed 's/--output=//'`
b39f9d20 87 ;;
68807e5f 88 -*)
89 echo "Unrecognized option \`$option'" 1>&2
90 usage
91 exit 1
92 ;;
044e2e60 93 # Explicitly ignore non-option arguments, for compatibility.
68807e5f 94 esac
95done
96
77546584 97. ${libdir}/@PACKAGE@/grub-mkconfig_lib
42c71976 98
991477f8 99if [ "x$EUID" = "x" ] ; then
100 EUID=`id -u`
ebd97f6e 101fi
102
991477f8 103if [ "$EUID" != 0 ] ; then
b609876d 104 root=f
105 case "`uname 2>/dev/null`" in
106 CYGWIN*)
107 # Cygwin: Assume root if member of admin group
108 for g in `id -G 2>/dev/null` ; do
109 case $g in
110 0|544) root=t ;;
111 esac
112 done ;;
113 esac
114 if [ $root != t ] ; then
0ea7c4f9 115 echo "$self: You must run this as root" >&2
b609876d 116 exit 1
117 fi
ebd97f6e 118fi
119
2e610d62 120set $grub_probe dummy
121if test -f "$1"; then
122 :
123else
124 echo "$1: Not found." 1>&2
125 exit 1
ebd97f6e 126fi
127
601c84fd 128mkdir -p ${GRUB_PREFIX}
2e610d62 129
cc85c3c3 130# Device containing our userland. Typically used for root= parameter.
69ba137e 131GRUB_DEVICE="`${grub_probe} --target=device /`"
132GRUB_DEVICE_UUID="`${grub_probe} --device ${GRUB_DEVICE} --target=fs_uuid 2> /dev/null`" || true
62191274 133
134# Device containing our /boot partition. Usually the same as GRUB_DEVICE.
69ba137e 135GRUB_DEVICE_BOOT="`${grub_probe} --target=device /boot`"
136GRUB_DEVICE_BOOT_UUID="`${grub_probe} --device ${GRUB_DEVICE_BOOT} --target=fs_uuid 2> /dev/null`" || true
57f96397 137
138# Filesystem for the device containing our userland. Used for stuff like
139# choosing Hurd filesystem module.
99fd620d 140GRUB_FS="`${grub_probe} --device ${GRUB_DEVICE} --target=fs 2> /dev/null || echo unknown`"
57f96397 141
ebd97f6e 142if test -f ${sysconfdir}/default/grub ; then
143 . ${sysconfdir}/default/grub
144fi
145
651c29b7 146# XXX: should this be deprecated at some point?
147if [ "x${GRUB_TERMINAL}" != "x" ] ; then
148 GRUB_TERMINAL_INPUT="${GRUB_TERMINAL}"
149 GRUB_TERMINAL_OUTPUT="${GRUB_TERMINAL}"
150fi
151
d5631db0 152termoutdefault=0
38e55e90 153if [ "x${GRUB_TERMINAL_OUTPUT}" = "x" ]; then
d5631db0
VS
154 GRUB_TERMINAL_OUTPUT=gfxterm;
155 termoutdefault=1;
156fi
157
158for x in ${GRUB_TERMINAL_OUTPUT}; do
38e55e90 159 if [ "x${x}" = "xgfxterm" ]; then
d5631db0
VS
160 if [ -n "$GRUB_FONT" ] ; then
161 if is_path_readable_by_grub ${GRUB_FONT} > /dev/null ; then
162 GRUB_FONT_PATH=${GRUB_FONT}
163 else
164 echo "No such font or not readable by grub: ${GRUB_FONT}" >&2
165 exit 1
166 fi
b969c52f 167 else
b9fe6ea2 168 for dir in ${pkgdatadir} ${GRUB_PREFIX} /usr/share/grub ; do
d5631db0
VS
169 for basename in unicode unifont ascii; do
170 path="${dir}/${basename}.pf2"
171 if is_path_readable_by_grub ${path} > /dev/null ; then
172 GRUB_FONT_PATH=${path}
173 else
174 continue
175 fi
176 if [ "${basename}" = "ascii" ] ; then
177 # make sure all our children behave in conformance with ascii..
178 export LANG=C
179 fi
180 break 2
181 done
182 done
183 fi
184 if [ -z "${GRUB_FONT_PATH}" ] ; then
185 if [ "x$termoutdefault" != "x1" ]; then
186 echo "No font for gfxterm found." >&2 ; exit 1
187 fi
188 GRUB_TERMINAL_OUTPUT=
b969c52f 189 fi
29a6b9e8 190 fi
d5631db0
VS
191done
192
193for x in ${GRUB_TERMINAL_OUTPUT}; do
194 case "x${x}" in
195 xgfxterm) ;;
196 xconsole | xserial | xofconsole)
197 # make sure all our children behave in conformance with ascii..
198 export LANG=C;;
199 *) echo "Invalid output terminal \"${GRUB_TERMINAL_OUTPUT}\"" >&2 ; exit 1 ;;
200 esac
201done
6193defe 202
57f96397 203# These are defined in this script, export them here so that user can
204# override them.
9a10df16 205export GRUB_DEVICE \
206 GRUB_DEVICE_UUID \
207 GRUB_DEVICE_BOOT \
208 GRUB_DEVICE_BOOT_UUID \
209 GRUB_FS \
210 GRUB_FONT_PATH \
3b76e68b 211 GRUB_PRELOAD_MODULES \
601c84fd 212 GRUB_PREFIX
57f96397 213
214# These are optional, user-defined variables.
9a10df16 215export GRUB_DEFAULT \
216 GRUB_HIDDEN_TIMEOUT \
217 GRUB_HIDDEN_TIMEOUT_QUIET \
218 GRUB_TIMEOUT \
76e6d0d7
VS
219 GRUB_DEFAULT_BUTTON \
220 GRUB_HIDDEN_TIMEOUT_BUTTON \
221 GRUB_TIMEOUT_BUTTON \
222 GRUB_BUTTON_CMOS_ADDRESS \
eaf41b25 223 GRUB_BUTTON_CMOS_CLEAN \
9a10df16 224 GRUB_DISTRIBUTOR \
225 GRUB_CMDLINE_LINUX \
226 GRUB_CMDLINE_LINUX_DEFAULT \
19dcc490
VS
227 GRUB_CMDLINE_XEN \
228 GRUB_CMDLINE_XEN_DEFAULT \
f35fa3a6
CW
229 GRUB_CMDLINE_LINUX_XEN_REPLACE \
230 GRUB_CMDLINE_LINUX_XEN_REPLACE_DEFAULT \
0d2c20c6
GS
231 GRUB_CMDLINE_NETBSD \
232 GRUB_CMDLINE_NETBSD_DEFAULT \
9a10df16 233 GRUB_TERMINAL_INPUT \
234 GRUB_TERMINAL_OUTPUT \
235 GRUB_SERIAL_COMMAND \
236 GRUB_DISABLE_LINUX_UUID \
219b3564 237 GRUB_DISABLE_RECOVERY \
e4311a9f 238 GRUB_VIDEO_BACKEND \
5174302b 239 GRUB_GFXMODE \
d7c43ba1 240 GRUB_BACKGROUND \
eb1c9594 241 GRUB_THEME \
65a533e7 242 GRUB_GFXPAYLOAD_LINUX \
0a39de87 243 GRUB_DISABLE_OS_PROBER \
a0ca21c2 244 GRUB_INIT_TUNE \
d500ed12 245 GRUB_SAVEDEFAULT \
20a40940 246 GRUB_ENABLE_CRYPTODISK \
d500ed12 247 GRUB_BADRAM
57f96397 248
18ade780 249if test "x${grub_cfg}" != "x"; then
250 rm -f ${grub_cfg}.new
251 exec > ${grub_cfg}.new
57f96397 252
18ade780 253 # Allow this to fail, since /boot/grub/ might need to be fatfs to support some
254 # firmware implementations (e.g. OFW or EFI).
8aa1541a 255 chmod 400 ${grub_cfg}.new || grub_warn "Could not make ${grub_cfg}.new readable by only root.\
256 This means that if the generated config contains a password it is readable by everyone"
18ade780 257fi
258echo "Generating grub.cfg ..." >&2
ebd97f6e 259
260cat << EOF
261#
262# DO NOT EDIT THIS FILE
263#
0ea7c4f9 264# It is automatically generated by $self using templates
f6fd460a 265# from ${grub_mkconfig_dir} and settings from ${sysconfdir}/default/grub
ebd97f6e 266#
267EOF
268
18ade780 269for i in ${grub_mkconfig_dir}/* ; do
53b052de 270 case "$i" in
ebd97f6e 271 # emacsen backup files. FIXME: support other editors
272 *~) ;;
6d1fa41f
MZ
273 # emacsen autosave files. FIXME: support other editors
274 \#*\#) ;;
ebd97f6e 275 *)
2f80039d 276 if grub_file_is_not_garbage "$i" && test -x "$i" ; then
ebd97f6e 277 echo
278 echo "### BEGIN $i ###"
53b052de 279 "$i"
ebd97f6e 280 echo "### END $i ###"
281 fi
282 ;;
283 esac
284done
285
18ade780 286if test "x${grub_cfg}" != "x" ; then
4417aae6 287 if ! ${grub_script_check} ${grub_cfg}.new; then
75d8c629 288 echo "Syntax errors are detected in generated GRUB config file." >&2
289 echo "Ensure that there are no errors in /etc/default/grub" >&2
290 echo "and /etc/grub.d/* files or please file a bug report with" >&2
291 echo "${grub_cfg}.new file attached." >&2
292 else
293 # none of the children aborted with error, install the new grub.cfg
294 mv -f ${grub_cfg}.new ${grub_cfg}
295 fi
18ade780 296fi
ebd97f6e 297
298echo "done" >&2